searchData={"items":[{"type":"module","title":"AshSqlite","doc":"The AshSqlite extension gives you tools to map a resource to a sqlite database table.\n\nFor more, check out the [getting started guide](/documentation/tutorials/getting-started-with-ash-sqlite.md)","ref":"AshSqlite.html"},{"type":"module","title":"AshSqlite.DataLayer","doc":"A sqlite data layer that leverages Ecto's sqlite capabilities.","ref":"AshSqlite.DataLayer.html"},{"type":"function","title":"AshSqlite.DataLayer.add_known_binding/3","doc":"","ref":"AshSqlite.DataLayer.html#add_known_binding/3"},{"type":"function","title":"AshSqlite.DataLayer.codegen/1","doc":"","ref":"AshSqlite.DataLayer.html#codegen/1"},{"type":"function","title":"AshSqlite.DataLayer.from_ecto/1","doc":"","ref":"AshSqlite.DataLayer.html#from_ecto/1"},{"type":"function","title":"AshSqlite.DataLayer.install/4","doc":"","ref":"AshSqlite.DataLayer.html#install/4"},{"type":"function","title":"AshSqlite.DataLayer.install/5","doc":"","ref":"AshSqlite.DataLayer.html#install/5"},{"type":"function","title":"AshSqlite.DataLayer.migrate/1","doc":"","ref":"AshSqlite.DataLayer.html#migrate/1"},{"type":"function","title":"AshSqlite.DataLayer.rollback/1","doc":"","ref":"AshSqlite.DataLayer.html#rollback/1"},{"type":"function","title":"AshSqlite.DataLayer.setup/1","doc":"","ref":"AshSqlite.DataLayer.html#setup/1"},{"type":"macro","title":"AshSqlite.DataLayer.sqlite/1","doc":"","ref":"AshSqlite.DataLayer.html#sqlite/1"},{"type":"function","title":"AshSqlite.DataLayer.tear_down/1","doc":"","ref":"AshSqlite.DataLayer.html#tear_down/1"},{"type":"function","title":"AshSqlite.DataLayer.to_ecto/1","doc":"","ref":"AshSqlite.DataLayer.html#to_ecto/1"},{"type":"behaviour","title":"AshSqlite.Repo","doc":"Resources that use `AshSqlite.DataLayer` use a `Repo` to access the database.\n\nThis repo is a thin wrapper around an `Ecto.Repo`.\n\nYou can use `Ecto.Repo`'s `init/2` to configure your repo like normal, but\ninstead of returning `{:ok, config}`, use `super(config)` to pass the\nconfiguration to the `AshSqlite.Repo` implementation.","ref":"AshSqlite.Repo.html"},{"type":"behaviour","title":"Additional Repo Configuration - AshSqlite.Repo","doc":"Because an `AshPostgres.Repo` is also an `Ecto.Repo`, it has all of the same callbacks.\n\nIn the `c:Ecto.Repo.init/2` callback, you can configure the following additional items:\n\n- `:tenant_migrations_path` - The path where your tenant migrations are stored (only relevant for a multitenant implementation)\n- `:snapshots_path` - The path where the resource snapshots for the migration generator are stored.","ref":"AshSqlite.Repo.html#module-additional-repo-configuration"},{"type":"callback","title":"AshSqlite.Repo.installed_extensions/0","doc":"Use this to inform the data layer about what extensions are installed","ref":"AshSqlite.Repo.html#c:installed_extensions/0"},{"type":"callback","title":"AshSqlite.Repo.migrations_path/0","doc":"The path where your migrations are stored","ref":"AshSqlite.Repo.html#c:migrations_path/0"},{"type":"callback","title":"AshSqlite.Repo.min_pg_version/0","doc":"Use this to inform the data layer about the oldest potential sqlite version it will be run on.\n\nMust be an integer greater than or equal to 13.","ref":"AshSqlite.Repo.html#c:min_pg_version/0"},{"type":"callback","title":"AshSqlite.Repo.override_migration_type/1","doc":"Allows overriding a given migration type for *all* fields, for example if you wanted to always use :timestamptz for :utc_datetime fields","ref":"AshSqlite.Repo.html#c:override_migration_type/1"},{"type":"behaviour","title":"AshSqlite.ManualRelationship","doc":"A behavior for sqlite-specific manual relationship functionality","ref":"AshSqlite.ManualRelationship.html"},{"type":"callback","title":"AshSqlite.ManualRelationship.ash_sqlite_join/6","doc":"","ref":"AshSqlite.ManualRelationship.html#c:ash_sqlite_join/6"},{"type":"callback","title":"AshSqlite.ManualRelationship.ash_sqlite_subquery/4","doc":"","ref":"AshSqlite.ManualRelationship.html#c:ash_sqlite_subquery/4"},{"type":"behaviour","title":"AshSqlite.CustomExtension","doc":"A custom extension implementation.","ref":"AshSqlite.CustomExtension.html"},{"type":"callback","title":"AshSqlite.CustomExtension.install/1","doc":"","ref":"AshSqlite.CustomExtension.html#c:install/1"},{"type":"callback","title":"AshSqlite.CustomExtension.uninstall/1","doc":"","ref":"AshSqlite.CustomExtension.html#c:uninstall/1"},{"type":"module","title":"AshSqlite.CustomIndex","doc":"Represents a custom index on the table backing a resource","ref":"AshSqlite.CustomIndex.html"},{"type":"function","title":"AshSqlite.CustomIndex.fields/0","doc":"","ref":"AshSqlite.CustomIndex.html#fields/0"},{"type":"function","title":"AshSqlite.CustomIndex.name/2","doc":"","ref":"AshSqlite.CustomIndex.html#name/2"},{"type":"function","title":"AshSqlite.CustomIndex.schema/0","doc":"","ref":"AshSqlite.CustomIndex.html#schema/0"},{"type":"function","title":"AshSqlite.CustomIndex.transform/1","doc":"","ref":"AshSqlite.CustomIndex.html#transform/1"},{"type":"module","title":"AshSqlite.DataLayer.Info","doc":"Introspection functions for","ref":"AshSqlite.DataLayer.Info.html"},{"type":"function","title":"AshSqlite.DataLayer.Info.base_filter_sql/1","doc":"A stringified version of the base_filter, to be used in a where clause when generating unique indexes","ref":"AshSqlite.DataLayer.Info.html#base_filter_sql/1"},{"type":"function","title":"AshSqlite.DataLayer.Info.custom_indexes/1","doc":"The configured custom_indexes for a resource","ref":"AshSqlite.DataLayer.Info.html#custom_indexes/1"},{"type":"function","title":"AshSqlite.DataLayer.Info.custom_statements/1","doc":"The configured custom_statements for a resource","ref":"AshSqlite.DataLayer.Info.html#custom_statements/1"},{"type":"function","title":"AshSqlite.DataLayer.Info.exclusion_constraint_names/1","doc":"The configured exclusion_constraint_names","ref":"AshSqlite.DataLayer.Info.html#exclusion_constraint_names/1"},{"type":"function","title":"AshSqlite.DataLayer.Info.foreign_key_names/1","doc":"The configured foreign_key_names","ref":"AshSqlite.DataLayer.Info.html#foreign_key_names/1"},{"type":"function","title":"AshSqlite.DataLayer.Info.global_upsert_keys/1","doc":"A list of keys to always include in upserts.","ref":"AshSqlite.DataLayer.Info.html#global_upsert_keys/1"},{"type":"function","title":"AshSqlite.DataLayer.Info.identity_index_names/1","doc":"The configured identity_index_names","ref":"AshSqlite.DataLayer.Info.html#identity_index_names/1"},{"type":"function","title":"AshSqlite.DataLayer.Info.migrate?/1","doc":"Whether or not the resource should be included when generating migrations","ref":"AshSqlite.DataLayer.Info.html#migrate?/1"},{"type":"function","title":"AshSqlite.DataLayer.Info.migration_defaults/1","doc":"A keyword list of customized migration defaults","ref":"AshSqlite.DataLayer.Info.html#migration_defaults/1"},{"type":"function","title":"AshSqlite.DataLayer.Info.migration_ignore_attributes/1","doc":"A list of attributes to be ignored when generating migrations","ref":"AshSqlite.DataLayer.Info.html#migration_ignore_attributes/1"},{"type":"function","title":"AshSqlite.DataLayer.Info.migration_types/1","doc":"A keyword list of customized migration types","ref":"AshSqlite.DataLayer.Info.html#migration_types/1"},{"type":"function","title":"AshSqlite.DataLayer.Info.polymorphic?/1","doc":"The configured polymorphic? for a resource","ref":"AshSqlite.DataLayer.Info.html#polymorphic?/1"},{"type":"function","title":"AshSqlite.DataLayer.Info.polymorphic_name/1","doc":"The configured polymorphic_reference_name for a resource","ref":"AshSqlite.DataLayer.Info.html#polymorphic_name/1"},{"type":"function","title":"AshSqlite.DataLayer.Info.polymorphic_on_delete/1","doc":"The configured polymorphic_reference_on_delete for a resource","ref":"AshSqlite.DataLayer.Info.html#polymorphic_on_delete/1"},{"type":"function","title":"AshSqlite.DataLayer.Info.polymorphic_on_update/1","doc":"The configured polymorphic_reference_on_update for a resource","ref":"AshSqlite.DataLayer.Info.html#polymorphic_on_update/1"},{"type":"function","title":"AshSqlite.DataLayer.Info.reference/2","doc":"The configured reference for a given relationship of a  resource","ref":"AshSqlite.DataLayer.Info.html#reference/2"},{"type":"function","title":"AshSqlite.DataLayer.Info.references/1","doc":"The configured references for a resource","ref":"AshSqlite.DataLayer.Info.html#references/1"},{"type":"function","title":"AshSqlite.DataLayer.Info.repo/1","doc":"The configured repo for a resource","ref":"AshSqlite.DataLayer.Info.html#repo/1"},{"type":"function","title":"AshSqlite.DataLayer.Info.skip_identities/1","doc":"Identities not to include in the migrations","ref":"AshSqlite.DataLayer.Info.html#skip_identities/1"},{"type":"function","title":"AshSqlite.DataLayer.Info.skip_unique_indexes/1","doc":"Skip generating unique indexes when generating migrations","ref":"AshSqlite.DataLayer.Info.html#skip_unique_indexes/1"},{"type":"function","title":"AshSqlite.DataLayer.Info.strict?/1","doc":"Whether the migration generator should create a strict table","ref":"AshSqlite.DataLayer.Info.html#strict?/1"},{"type":"function","title":"AshSqlite.DataLayer.Info.table/1","doc":"The configured table for a resource","ref":"AshSqlite.DataLayer.Info.html#table/1"},{"type":"function","title":"AshSqlite.DataLayer.Info.unique_index_names/1","doc":"The configured unique_index_names","ref":"AshSqlite.DataLayer.Info.html#unique_index_names/1"},{"type":"module","title":"AshSqlite.Reference","doc":"Represents the configuration of a reference (i.e foreign key).","ref":"AshSqlite.Reference.html"},{"type":"function","title":"AshSqlite.Reference.schema/0","doc":"","ref":"AshSqlite.Reference.html#schema/0"},{"type":"module","title":"AshSqlite.Statement","doc":"Represents a custom statement to be run in generated migrations","ref":"AshSqlite.Statement.html"},{"type":"function","title":"AshSqlite.Statement.fields/0","doc":"","ref":"AshSqlite.Statement.html#fields/0"},{"type":"function","title":"AshSqlite.Statement.schema/0","doc":"","ref":"AshSqlite.Statement.html#schema/0"},{"type":"behaviour","title":"AshSqlite.Type","doc":"Sqlite specific callbacks for `Ash.Type`.\n\nUse this in addition to `Ash.Type`.","ref":"AshSqlite.Type.html"},{"type":"callback","title":"AshSqlite.Type.value_to_sqlite_default/3","doc":"","ref":"AshSqlite.Type.html#c:value_to_sqlite_default/3"},{"type":"module","title":"AshSqlite.Functions.Like","doc":"Maps to the builtin sqlite function `like`.","ref":"AshSqlite.Functions.Like.html"},{"type":"function","title":"AshSqlite.Functions.Like.args/0","doc":"Callback implementation for  Ash.Query.Function.args/0 .","ref":"AshSqlite.Functions.Like.html#args/0"},{"type":"module","title":"AshSqlite.Functions.ILike","doc":"Maps to the builtin sqlite function `ilike`.","ref":"AshSqlite.Functions.ILike.html"},{"type":"function","title":"AshSqlite.Functions.ILike.args/0","doc":"Callback implementation for  Ash.Query.Function.args/0 .","ref":"AshSqlite.Functions.ILike.html#args/0"},{"type":"task","title":"mix ash_sqlite.create","doc":"Create the storage for repos in all resources for the given (or configured) domains.","ref":"Mix.Tasks.AshSqlite.Create.html"},{"type":"task","title":"Examples - mix ash_sqlite.create","doc":"mix ash_sqlite.create\n    mix ash_sqlite.create --domains MyApp.Domain1,MyApp.Domain2","ref":"Mix.Tasks.AshSqlite.Create.html#module-examples"},{"type":"task","title":"Command line options - mix ash_sqlite.create","doc":"* `--domains` - the domains who's repos you want to migrate.\n  * `--quiet` - do not log output\n  * `--no-compile` - do not compile before creating\n  * `--no-deps-check` - do not compile before creating","ref":"Mix.Tasks.AshSqlite.Create.html#module-command-line-options"},{"type":"task","title":"mix ash_sqlite.drop","doc":"Drop the storage for the given repository.","ref":"Mix.Tasks.AshSqlite.Drop.html"},{"type":"task","title":"Examples - mix ash_sqlite.drop","doc":"mix ash_sqlite.drop\n    mix ash_sqlite.drop -d MyApp.Domain1,MyApp.Domain2","ref":"Mix.Tasks.AshSqlite.Drop.html#module-examples"},{"type":"task","title":"Command line options - mix ash_sqlite.drop","doc":"* `--domains` - the domains who's repos should be dropped\n  * `-q`, `--quiet` - run the command quietly\n  * `-f`, `--force` - do not ask for confirmation when dropping the database.\n    Configuration is asked only when `:start_permanent` is set to true\n    (typically in production)\n  * `--no-compile` - do not compile before dropping\n  * `--no-deps-check` - do not compile before dropping","ref":"Mix.Tasks.AshSqlite.Drop.html#module-command-line-options"},{"type":"task","title":"mix ash_sqlite.generate_migrations","doc":"Generates migrations, and stores a snapshot of your resources.\n\nOptions:\n\n* `domains` - a comma separated list of domain modules, for which migrations will be generated\n* `snapshot-path` - a custom path to store the snapshots, defaults to \"priv/resource_snapshots\"\n* `migration-path` - a custom path to store the migrations, defaults to \"priv\".\n  Migrations are stored in a folder for each repo, so `priv/repo_name/migrations`\n* `drop-columns` - whether or not to drop columns as attributes are removed. See below for more\n* `name` -\n    names the generated migrations, prepending with the timestamp. The default is `migrate_resources_ `,\n    where ` ` is the count of migrations matching `*migrate_resources*` plus one.\n    For example, `--name add_special_column` would get a name like `20210708181402_add_special_column.exs`\n\nFlags:\n\n* `quiet` - messages for file creations will not be printed\n* `no-format` - files that are created will not be formatted with the code formatter\n* `dry-run` - no files are created, instead the new migration is printed\n* `check` - no files are created, returns an exit(1) code if the current snapshots and resources don't fit\n* `dev` - dev files are created (see Development Workflow section below)\n\n#### Snapshots\n\nSnapshots are stored in a folder for each table that migrations are generated for. Each snapshot is\nstored in a file with a timestamp of when it was generated.\nThis is important because it allows for simultaneous work to be done on separate branches, and for rolling back\nchanges more easily, e.g removing a generated migration, and deleting the most recent snapshot, without having to redo\nall of it\n\n#### Dropping columns\n\nGenerally speaking, it is bad practice to drop columns when you deploy a change that\nwould remove an attribute. The main reasons for this are backwards compatibility and rolling restarts.\nIf you deploy an attribute removal, and run migrations. Regardless of your deployment sstrategy, you\nwon't be able to roll back, because the data has been deleted. In a rolling restart situation, some of\nthe machines/pods/whatever may still be running after the column has been deleted, causing errors. With\nthis in mind, its best not to delete those columns until later, after the data has been confirmed unnecessary.\nTo that end, the migration generator leaves the column dropping code commented. You can pass `--drop_columns`\nto tell it to uncomment those statements. Additionally, you can just uncomment that code on a case by case\nbasis.\n\n#### Conflicts/Multiple Resources\n\nIt will raise on conflicts that it can't resolve, like the same field with different\ntypes. It will prompt to resolve conflicts that can be resolved with human input.\nFor example, if you remove an attribute and add an attribute, it will ask you if you are renaming\nthe column in question. If not, it will remove one column and add the other.\n\nAdditionally, it lowers things to the database where possible:\n\n#### Defaults\nThere are three anonymous functions that will translate to database-specific defaults currently:\n\n* `&DateTime.utc_now/0`\n\nNon-function default values will be dumped to their native type and inspected. This may not work for some types,\nand may require manual intervention/patches to the migration generator code.\n\n#### Development Workflow\n\nThe `--dev` flag enables a development-focused migration workflow that allows you to iterate\non resource changes without committing to migration names prematurely:\n\n1. Make resource changes\n2. Run `mix ash_sqlite.generate_migrations --dev` to generate dev migrations\n   - Creates migration files with `_dev.exs` suffix\n   - Creates snapshot files with `_dev.json` suffix\n   - No migration name required\n3. Continue making changes and running `--dev` as needed\n4. When ready, run `mix ash_sqlite.generate_migrations my_feature_name` to:\n   - Remove all dev migrations and snapshots\n   - Generate final named migrations that consolidate all changes\n   - Create clean snapshots\n\nThis workflow prevents migration history pollution during development while maintaining\nthe ability to generate clean, well-named migrations for production.\n\n#### Identities\n\nIdentities will cause the migration generator to generate unique constraints. If multiple\nresources target the same table, you will be asked to select the primary key, and any others\nwill be added as unique constraints.","ref":"Mix.Tasks.AshSqlite.GenerateMigrations.html"},{"type":"function","title":"Mix.Tasks.AshSqlite.GenerateMigrations.run/1","doc":"Callback implementation for  Mix.Task.run/1 .","ref":"Mix.Tasks.AshSqlite.GenerateMigrations.html#run/1"},{"type":"task","title":"mix ash_sqlite.install","doc":"Installs AshSqlite. Should be run with `mix igniter.install ash_sqlite`","ref":"Mix.Tasks.AshSqlite.Install.html"},{"type":"task","title":"mix ash_sqlite.migrate","doc":"Runs the pending migrations for the given repository.\n\nMigrations are expected at \"priv/YOUR_REPO/migrations\" directory\nof the current application, where \"YOUR_REPO\" is the last segment\nin your repository name. For example, the repository `MyApp.Repo`\nwill use \"priv/repo/migrations\". The repository `Whatever.MyRepo`\nwill use \"priv/my_repo/migrations\".\n\nThis task runs all pending migrations by default. To migrate up to a\nspecific version number, supply `--to version_number`. To migrate a\nspecific number of times, use `--step n`.\n\nThis is only really useful if your domain or domains only use a single repo.\nIf you have multiple repos and you want to run a single migration and/or\nmigrate/roll them back to different points, you will need to use the\necto specific task, `mix ecto.migrate` and provide your repo name.\n\nIf a repository has not yet been started, one will be started outside\nyour application supervision tree and shutdown afterwards.","ref":"Mix.Tasks.AshSqlite.Migrate.html"},{"type":"task","title":"Examples - mix ash_sqlite.migrate","doc":"mix ash_sqlite.migrate\n    mix ash_sqlite.migrate --domains MyApp.Domain1,MyApp.Domain2\n\n    mix ash_sqlite.migrate -n 3\n    mix ash_sqlite.migrate --step 3\n\n    mix ash_sqlite.migrate --to 20080906120000","ref":"Mix.Tasks.AshSqlite.Migrate.html#module-examples"},{"type":"task","title":"Command line options - mix ash_sqlite.migrate","doc":"* `--domains` - the domains who's repos should be migrated\n\n  * `--all` - run all pending migrations\n\n  * `--step`, `-n` - run n number of pending migrations\n\n  * `--to` - run all migrations up to and including version\n\n  * `--quiet` - do not log migration commands\n\n  * `--pool-size` - the pool size if the repository is started only for the task (defaults to 2)\n\n  * `--log-sql` - log the raw sql migrations are running\n\n  * `--strict-version-order` - abort when applying a migration with old timestamp\n\n  * `--no-compile` - does not compile applications before migrating\n\n  * `--no-deps-check` - does not check depedendencies before migrating\n\n  * `--migrations-path` - the path to load the migrations from, defaults to\n    `\"priv/repo/migrations\"`. This option may be given multiple times in which case the migrations\n    are loaded from all the given directories and sorted as if they were in the same one.\n\n    Note, if you have migrations paths e.g. `a/` and `b/`, and run\n    `mix ecto.migrate --migrations-path a/`, the latest migrations from `a/` will be run (even\n    if `b/` contains the overall latest migrations.)","ref":"Mix.Tasks.AshSqlite.Migrate.html#module-command-line-options"},{"type":"task","title":"mix ash_sqlite.rollback","doc":"Reverts applied migrations in the given repository.\nMigrations are expected at \"priv/YOUR_REPO/migrations\" directory\nof the current application but it can be configured by specifying\nthe `:priv` key under the repository configuration.\nRuns the latest applied migration by default. To roll back to\na version number, supply `--to version_number`. To roll back a\nspecific number of times, use `--step n`. To undo all applied\nmigrations, provide `--all`.\n\nThis is only really useful if your domain or domains only use a single repo.\nIf you have multiple repos and you want to run a single migration and/or\nmigrate/roll them back to different points, you will need to use the\necto specific task, `mix ecto.migrate` and provide your repo name.","ref":"Mix.Tasks.AshSqlite.Rollback.html"},{"type":"task","title":"Examples - mix ash_sqlite.rollback","doc":"mix ash_sqlite.rollback\n    mix ash_sqlite.rollback -r Custom.Repo\n    mix ash_sqlite.rollback -n 3\n    mix ash_sqlite.rollback --step 3\n    mix ash_sqlite.rollback -v 20080906120000\n    mix ash_sqlite.rollback --to 20080906120000","ref":"Mix.Tasks.AshSqlite.Rollback.html#module-examples"},{"type":"task","title":"Command line options - mix ash_sqlite.rollback","doc":"* `--domains` - the domains who's repos should be rolledback\n  * `--all` - revert all applied migrations\n  * `--step` / `-n` - revert n number of applied migrations\n  * `--to` / `-v` - revert all migrations down to and including version\n  * `--quiet` - do not log migration commands\n  * `--pool-size` - the pool size if the repository is started only for the task (defaults to 1)\n  * `--log-sql` - log the raw sql migrations are running","ref":"Mix.Tasks.AshSqlite.Rollback.html#module-command-line-options"},{"type":"extras","title":"Home","doc":"![Logo](https://github.com/ash-project/ash/blob/main/logos/cropped-for-header-black-text.png?raw=true#gh-light-mode-only)\n![Logo](https://github.com/ash-project/ash/blob/main/logos/cropped-for-header-white-text.png?raw=true#gh-dark-mojde-only)\n\n[![CI](https://github.com/ash-project/ash_sqlite/actions/workflows/elixir.yml/badge.svg)](https://github.com/ash-project/ash_sqlite/actions/workflows/elixir.yml)\n[![License: MIT](https://img.shields.io/badge/License-MIT-yellow.svg)](https://opensource.org/licenses/MIT)\n[![Hex version badge](https://img.shields.io/hexpm/v/ash_sqlite.svg)](https://hex.pm/packages/ash_sqlite)\n[![Hexdocs badge](https://img.shields.io/badge/docs-hexdocs-purple)](https://hexdocs.pm/ash_sqlite)\n\n# AshSqlite\n\nWelcome! `AshSqlite` is the SQLite data layer for [Ash Framework](https://hexdocs.pm/ash).","ref":"readme.html"},{"type":"extras","title":"Tutorials - Home","doc":"- [Get Started](documentation/tutorials/getting-started-with-ash-sqlite.md)","ref":"readme.html#tutorials"},{"type":"extras","title":"Topics - Home","doc":"- [What is AshSqlite?](documentation/topics/about-ash-sqlite/what-is-ash-sqlite.md)","ref":"readme.html#topics"},{"type":"extras","title":"Resources - Home","doc":"- [References](documentation/topics/resources/references.md)\n- [Polymorphic Resources](documentation/topics/resources/polymorphic-resources.md)","ref":"readme.html#resources"},{"type":"extras","title":"Development - Home","doc":"- [Migrations and tasks](documentation/topics/development/migrations-and-tasks.md)\n- [Testing](documentation/topics/development/testing.md)","ref":"readme.html#development"},{"type":"extras","title":"Advanced - Home","doc":"- [Expressions](documentation/topics/advanced/expressions.md)\n- [Manual Relationships](documentation/topics/advanced/manual-relationships.md)","ref":"readme.html#advanced"},{"type":"extras","title":"Reference - Home","doc":"- [AshSqlite.DataLayer DSL](documentation/dsls/DSL-AshSqlite.DataLayer.md)","ref":"readme.html#reference"},{"type":"extras","title":"Getting Started With AshSqlite","doc":"# Getting Started With AshSqlite","ref":"getting-started-with-ash-sqlite.html"},{"type":"extras","title":"Goals - Getting Started With AshSqlite","doc":"In this guide we will:\n\n1. Setup AshSqlite, which includes setting up [Ecto](https://hexdocs.pm/ecto/Ecto.html)\n2. Add AshSqlite to the resources created in [the Ash getting started guide](https://hexdocs.pm/ash/get-started.html)\n3. Show how the various features of AshSqlite can help you work quickly and cleanly against a sqlite database\n4. Highlight some of the more advanced features you can use when using AshSqlite.\n5. Point you to additional resources you may need on your journey","ref":"getting-started-with-ash-sqlite.html#goals"},{"type":"extras","title":"Requirements - Getting Started With AshSqlite","doc":"","ref":"getting-started-with-ash-sqlite.html#requirements"},{"type":"extras","title":"Ash getting started guide - Getting Started With AshSqlite","doc":"If you would like to follow along, you will need to add begin with [the Ash getting started guide](https://hexdocs.pm/ash/get-started.html)","ref":"getting-started-with-ash-sqlite.html#ash-getting-started-guide"},{"type":"extras","title":"SQLite - Getting Started With AshSqlite","doc":"A working [SQLite](https://sqlite.org/) installation. Verify installation with `sqlite --version`","ref":"getting-started-with-ash-sqlite.html#sqlite"},{"type":"extras","title":"Steps - Getting Started With AshSqlite","doc":"","ref":"getting-started-with-ash-sqlite.html#steps"},{"type":"extras","title":"Add AshSqlite - Getting Started With AshSqlite","doc":"Add the `:ash_sqlite` dependency to your application\n\n`{:ash_sqlite, \"~> 0.2.11\"}`\n\nAdd `:ash_sqlite` to your `.formatter.exs` file\n\n```elixir\n[\n  # import the formatter rules from `:ash_sqlite`\n  import_deps: [..., :ash_sqlite],\n  inputs: [...]\n]\n```","ref":"getting-started-with-ash-sqlite.html#add-ashsqlite"},{"type":"extras","title":"Create and configure your Repo - Getting Started With AshSqlite","doc":"Create `lib/helpdesk/repo.ex` with the following contents. `AshSqlite.Repo` is a thin wrapper around `Ecto.Repo`, so see their documentation for how to use it if you need to use it directly. For standard Ash usage, all you will need to do is configure your resources to use your repo.\n\n```elixir\n# in lib/helpdesk/repo.ex\n\ndefmodule Helpdesk.Repo do\n  use AshSqlite.Repo, otp_app: :helpdesk\nend\n```\n\nNext we will need to create configuration files for various environments. Run the following to create the configuration files we need.\n\n```bash\nmkdir -p config\ntouch config/config.exs\ntouch config/dev.exs\ntouch config/runtime.exs\ntouch config/test.exs\n```\n\nPlace the following contents in those files, ensuring that the credentials match the user you created for your database. For most conventional installations this will work out of the box. If you've followed other guides before this one, they may have had you create these files already, so just make sure these contents are there.\n\n```elixir\n# in config/config.exs\nimport Config\n\n# This should already have been added from the getting started guide\nconfig :helpdesk,\n  ash_domains: [Helpdesk.Support]\n\nconfig :helpdesk,\n  ash_apis: [Helpdesk.Support]\n\nconfig :helpdesk,\n  ecto_repos: [Helpdesk.Repo]\n\n# Import environment specific config. This must remain at the bottom\n# of this file so it overrides the configuration defined above.\nimport_config \"#{config_env()}.exs\"\n```\n\n```elixir\n# in config/dev.exs\n\nimport Config\n\n# Configure your database\nconfig :helpdesk, Helpdesk.Repo,\n  database: Path.join(__DIR__, \"../path/to/your.db\"),\n  show_sensitive_data_on_connection_error: true,\n  pool_size: 10\n```\n\n```elixir\n# in config/runtime.exs\n\nimport Config\n\nif config_env() == :prod do\n  config :helpdesk, Helpdesk.Repo,\n    pool_size: String.to_integer(System.get_env(\"POOL_SIZE\") || \"10\")\nend\n```\n\n```elixir\n# in config/test.exs\n\nimport Config\n\n# Configure your database\n#\n# The MIX_TEST_PARTITION environment variable can be used\n# to provide built-in test partitioning in CI environment.\n# Run `mix help test` for more information.\nconfig :helpdesk, Helpdesk.Repo,\n  database: Path.join(__DIR__, \"../path/to/your#{System.get_env(\"MIX_TEST_PARTITION\")}.db\"),\n  pool: Ecto.Adapters.SQL.Sandbox,\n  pool_size: 10\n```\n\nadd the repo to your application\n\n```elixir\n\n\n# in lib/helpdesk/application.ex (when the file is already exists)\n\n  def start(_type, _args) do\n    children = [\n      # Starts a worker by calling: Helpdesk.Worker.start_link(arg)\n      # {Helpdesk.Worker, arg}\n      Helpdesk.Repo\n    ]\n\n    ...\n```\n\nIf the application file does not exist you can create a new one\n\n```elixir\n# in lib/helpdesk/application.ex (new file)\n\ndefmodule Helpdesk.Application do\n  @moduledoc false\n\n  use Application\n\n  def start(_type, _args) do\n    children = [\n      Helpdesk.Repo\n    ]\n\n    opts = [strategy: :one_for_one, name: Helpdesk.Supervisor]\n    Supervisor.start_link(children, opts)\n  end\nend\n```","ref":"getting-started-with-ash-sqlite.html#create-and-configure-your-repo"},{"type":"extras","title":"Add AshSqlite to our resources - Getting Started With AshSqlite","doc":"Now we can add the data layer to our resources. The basic configuration for a resource requires the `d:AshSqlite.sqlite|table` and the `d:AshSqlite.sqlite|repo`.\n\n```elixir\n# in lib/helpdesk/support/resources/ticket.ex\n\n  use Ash.Resource,\n    domain: Helpdesk.Support,\n    data_layer: AshSqlite.DataLayer\n\n  sqlite do\n    table \"tickets\"\n    repo Helpdesk.Repo\n  end\n```\n\n```elixir\n# in lib/helpdesk/support/resources/representative.ex\n\n  use Ash.Resource,\n    domain: Helpdesk.Support,\n    data_layer: AshSqlite.DataLayer\n\n  sqlite do\n    table \"representatives\"\n    repo Helpdesk.Repo\n  end\n```\n\n\nAnd finaly link the application in your\n\n```elixir\n# in mix.exs\n...\n  def application do\n    [\n      mod: {Helpdesk.Application, []},\n      ...\n    ]\n  end\n...\n```","ref":"getting-started-with-ash-sqlite.html#add-ashsqlite-to-our-resources"},{"type":"extras","title":"Create the database and tables - Getting Started With AshSqlite","doc":"First, we'll create the database with `mix ash_sqlite.create`.\n\nThen we will generate database migrations. This is one of the many ways that AshSqlite can save time and reduce complexity.\n\n```bash\nmix ash_sqlite.generate_migrations --name add_tickets_and_representatives\n```\n\n> **Development Tip**: For iterative development, you can use `mix ash_sqlite.generate_migrations --dev` to create dev migrations without needing to name them immediately. When you're ready to finalize your changes, run the command with a proper name to consolidate all dev migrations into a single, well-named migration.\n\nIf you are unfamiliar with database migrations, it is a good idea to get a rough idea of what they are and how they work. See the links at the bottom of this guide for more. A rough overview of how migrations work is that each time you need to make changes to your database, they are saved as small, reproducible scripts that can be applied in order. This is necessary both for clean deploys as well as working with multiple developers making changes to the structure of a single database.\n\nTypically, you need to write these by hand. AshSqlite, however, will store snapshots each time you run the command to generate migrations and will figure out what migrations need to be created.\n\nYou should always look at the generated migrations to ensure that they look correct. Do so now by looking at the generated file in `priv/repo/migrations`.\n\nFinally, we will create the local database and apply the generated migrations:\n\n```bash\nmix ash_sqlite.create\nmix ash_sqlite.migrate\n```","ref":"getting-started-with-ash-sqlite.html#create-the-database-and-tables"},{"type":"extras","title":"Try it out - Getting Started With AshSqlite","doc":"And now we're ready to try it out! Start iex with:\n\n```bash\niex -S mix\n```\n\nLets create some data. We'll make a representative and give them some open and some closed tickets.\n\n```elixir\n#### Create the Representative\n\nrepresentative = (\n  Helpdesk.Support.Representative\n  |> Ash.Changeset.for_create(:create, %{name: \"Joe Armstrong\"})\n  |> Ash.create!()\n)\n\n\n#### Create 5 Tickets, Assign representative, and Close Odd Ones\n\nfor i <- 1..5 do\n  # 1) open the ticket\n  ticket =\n    Helpdesk.Support.Ticket\n    |> Ash.Changeset.for_create(:open, %{subject: \"Issue #{i}\"})\n    |> Ash.create!()\n\n  # 2) assign the representative\n  ticket =\n    ticket\n    |> Ash.Changeset.for_update(:assign, %{representative_id: representative.id})\n    |> Ash.update!()\n\n  # 3) close if odd\n  if rem(i, 2) == 1 do\n    ticket\n    |> Ash.Changeset.for_update(:close, %{})\n    |> Ash.update!()\n  end\nend\n\n```\n\n\nAnd now we can read that data. You should see some debug logs that show the sql queries AshSqlite is generating.\n\n```elixir\nrequire Ash.Query\n\nHelpdesk.Support.Ticket\n|> Ash.Query.filter(contains(subject, \"2\"))\n|> Ash.read!()\n```\n\n```elixir\nrequire Ash.Query\n\n# Show the tickets that are closed and their subject does not equal \"barbaz\"\nHelpdesk.Support.Ticket\n|> Ash.Query.filter(status == :closed and not(subject == \"barbaz\"))\n|> Ash.read!()\n```\n\nAnd, naturally, now that we are storing this in sqlite, this database is persisted even if we stop/start our application. The nice thing, however, is that this was the _exact_ same code that we ran against our resources when they were backed by ETS.","ref":"getting-started-with-ash-sqlite.html#try-it-out"},{"type":"extras","title":"Calculations - Getting Started With AshSqlite","doc":"Simple calculation for Ticket which adds a concatenation of state and subject:\n\n```elixir\n# in lib/helpdesk/support/ticket.ex\ndefmodule Helpdesk.Support.Ticket do\n  ...\n  calculations do\n    calculate :status_subject, :string,\n    expr(\"#{status}: #{subject}\")\n  end\n\nend\n```\n\nTesting of this feature can be done via iex:\n\n```elixir\nAsh.Query\nHelpdesk.Support.Ticket\n|> Ash.Query.filter(status == :open)\n|> Ash.Query.load(:status_subject)\n|> Ash.read!()\n```","ref":"getting-started-with-ash-sqlite.html#calculations"},{"type":"extras","title":"Aggregates - Getting Started With AshSqlite","doc":"As stated in [what-is-ash-sqlite](https://hexdocs.pm/ash_sqlite/getting-started-with-ash-sqlite.html#steps),\n**The main feature missing is Aggregate support.**.\n\nIn order to use these consider using [ash_postgres](https://github.com/ash-project/ash_postgres) or\nprovide a patch.","ref":"getting-started-with-ash-sqlite.html#aggregates"},{"type":"extras","title":"Rich Configuration Options - Getting Started With AshSqlite","doc":"Take a look at the DSL documentation for more information on what you can configure. You can add check constraints, configure the behavior of foreign keys and more!","ref":"getting-started-with-ash-sqlite.html#rich-configuration-options"},{"type":"extras","title":"Deployment - Getting Started With AshSqlite","doc":"When deploying, you will need to ensure that the file you are using in production is persisted in some way (probably, unless you want it to disappear whenever your deployed system restarts). For example with fly.io this might mean adding a volume to your deployment.","ref":"getting-started-with-ash-sqlite.html#deployment"},{"type":"extras","title":"What next? - Getting Started With AshSqlite","doc":"- Check out the data layer docs: `AshSqlite.DataLayer`\n\n- [Ecto's documentation](https://hexdocs.pm/ecto/Ecto.html). AshSqlite (and much of Ash itself) is made possible by the amazing Ecto. If you find yourself looking for escape hatches when using Ash or ways to work directly with your database, you will want to know how Ecto works. Ash and AshSqlite intentionally do not hide Ecto, and in fact encourages its use whenever you need an escape hatch.\n\n- [Ecto's Migration documentation](https://hexdocs.pm/ecto_sql/Ecto.Migration.html) read more about migrations. Even with the ash_sqlite migration generator, you will very likely need to modify your own migrations some day.","ref":"getting-started-with-ash-sqlite.html#what-next"},{"type":"extras","title":"What is AshSqlite?","doc":"# What is AshSqlite?\n\nAshSqlite is the SQLite `Ash.DataLayer` for [Ash Framework](https://hexdocs.pm/ash). This doesn't have all of the features of [AshPostgres](https://hexdocs.pm/ash_postgres), but it does support most of the features of Ash data layers. The main feature missing is Aggregate support.\n\nUse this to persist records in a SQLite table. For example, the resource below would be persisted in a table called `tweets`:\n\n```elixir\ndefmodule MyApp.Tweet do\n  use Ash.Resource,\n    data_layer: AshSQLite.DataLayer\n\n  attributes do\n    integer_primary_key :id\n    attribute :text, :string\n  end\n\n  relationships do\n    belongs_to :author, MyApp.User\n  end\n\n  sqlite do\n    table \"tweets\"\n    repo MyApp.Repo\n  end\nend\n```\n\nThe table might look like this:\n\n| id  | text            | author_id |\n| --- | --------------- | --------- |\n| 1   | \"Hello, world!\" | 1         |\n\nCreating records would add to the table, destroying records would remove from the table, and updating records would update the table.","ref":"what-is-ash-sqlite.html"},{"type":"extras","title":"References","doc":"# References\n\nTo configure the foreign keys on a resource, we use the `references` block.\n\nFor example:\n\n```elixir\nreferences do\n  reference :post, on_delete: :delete, on_update: :update, name: \"comments_to_posts_fkey\"\nend\n```","ref":"references.html"},{"type":"extras","title":"Important - References","doc":"No resource logic is applied with these operations! No authorization rules or validations take place, and no notifications are issued. This operation happens *directly* in the database. That","ref":"references.html#important"},{"type":"extras","title":"Nothing vs Restrict - References","doc":"The difference between `:nothing` and `:restrict` is subtle and, if you are unsure, choose `:nothing` (the default behavior). `:restrict` will prevent the deletion from happening *before* the end of the database transaction, whereas `:nothing` allows the transaction to complete before doing so. This allows for things like updating or deleting the destination row and *then* updating updating or deleting the reference(as long as you are in a transaction).","ref":"references.html#nothing-vs-restrict"},{"type":"extras","title":"On Delete - References","doc":"This option is called `on_delete`, instead of `on_destroy`, because it is hooking into the database level deletion, *not* a `destroy` action in your resource.","ref":"references.html#on-delete"},{"type":"extras","title":"Polymorphic Resources","doc":"# Polymorphic Resources\n\nTo support leveraging the same resource backed by multiple tables (useful for things like polymorphic associations), AshSqlite supports setting the `data_layer.table` context for a given resource. For this example, lets assume that you have a `MyApp.Post` resource and a `MyApp.Comment` resource. For each of those resources, users can submit `reactions`. However, you want a separate table for `post_reactions` and `comment_reactions`. You could accomplish that like so:\n\n```elixir\ndefmodule MyApp.Reaction do\n  use Ash.Resource,\n    domain: MyApp.Domain,\n    data_layer: AshSqlite.DataLayer\n\n   sqlite do\n    polymorphic? true # Without this, `table` is a required configuration\n  end\n\n  attributes do\n    attribute(:resource_id, :uuid)\n  end\n\n  ...\nend\n```\n\nThen, in your related resources, you set the table context like so:\n\n```elixir\ndefmodule MyApp.Post do\n  use Ash.Resource,\n    domain: MyApp.Domain,\n    data_layer: AshSqlite.DataLayer\n\n  ...\n\n  relationships do\n    has_many :reactions, MyApp.Reaction,\n      relationship_context: %{data_layer: %{table: \"post_reactions\"}},\n      destination_attribute: :resource_id\n  end\nend\n\ndefmodule MyApp.Comment do\n  use Ash.Resource,\n    domain: MyApp.Domain,\n    data_layer: AshSqlite.DataLayer\n\n  ...\n\n  relationships do\n    has_many :reactions, MyApp.Reaction,\n      relationship_context: %{data_layer: %{table: \"comment_reactions\"}},\n      destination_attribute: :resource_id\n  end\nend\n```\n\nWith this, when loading or editing related data, ash will automatically set that context.\nFor managing related data, see `Ash.Changeset.manage_relationship/4` and other relationship functions\nin `Ash.Changeset`","ref":"polymorphic-resources.html"},{"type":"extras","title":"Table specific actions - Polymorphic Resources","doc":"To make actions use a specific table, you can use the `set_context` query preparation/change.\n\nFor example:\n\n```elixir\ndefmodule MyApp.Reaction do\n  actions do\n    read :for_comments do\n      prepare set_context(%{data_layer: %{table: \"comment_reactions\"}})\n    end\n\n    read :for_posts do\n      prepare set_context(%{data_layer: %{table: \"post_reactions\"}})\n    end\n  end\nend\n```","ref":"polymorphic-resources.html#table-specific-actions"},{"type":"extras","title":"Migrations - Polymorphic Resources","doc":"When a migration is marked as `polymorphic? true`, the migration generator will look at\nall resources that are related to it, that set the `%{data_layer: %{table: \"table\"}}` context.\nFor each of those, a migration is generated/managed automatically. This means that adding reactions\nto a new resource is as easy as adding the relationship and table context, and then running\n`mix ash_sqlite.generate_migrations`.","ref":"polymorphic-resources.html#migrations"},{"type":"extras","title":"Migrations","doc":"# Migrations","ref":"migrations-and-tasks.html"},{"type":"extras","title":"Tasks - Migrations","doc":"Ash comes with its own tasks, and AshSqlite exposes lower level tasks that you can use if necessary. This guide shows the process using `ash.*` tasks, and the `ash_sqlite.*` tasks are illustrated at the bottom.","ref":"migrations-and-tasks.html#tasks"},{"type":"extras","title":"Basic Workflow - Migrations","doc":"","ref":"migrations-and-tasks.html#basic-workflow"},{"type":"extras","title":"Development Workflow (Recommended) - Migrations","doc":"For development iterations, use the dev workflow to avoid naming migrations prematurely:\n\n1. Make resource changes\n2. Run `mix ash.codegen --dev` to generate dev migrations\n3. Review the migrations and run `mix ash.migrate` to run them\n4. Continue making changes and running `mix ash.codegen --dev` as needed\n5. When your feature is complete, run `mix ash.codegen add_feature_name` to generate final named migrations (this will remove dev migrations and squash them)\n6. Review the migrations and run `mix ash.migrate` to run them","ref":"migrations-and-tasks.html#development-workflow-recommended"},{"type":"extras","title":"Traditional Migration Generation - Migrations","doc":"For single-step changes or when you know the final feature name:\n\n1. Make resource changes\n2. Run `mix ash.codegen --name add_a_combobulator` to generate migrations and resource snapshots\n3. Run `mix ash.migrate` to run those migrations\n\n> **Tip**: The dev workflow (`--dev` flag) is preferred during development as it allows you to iterate without thinking of migration names and provides better development ergonomics.\n\n> **Warning**: Always review migrations before applying them to ensure they are correct and safe.\n\nFor more information on generating migrations, run `mix help ash_sqlite.generate_migrations` (the underlying task that is called by `mix ash.codegen`)","ref":"migrations-and-tasks.html#traditional-migration-generation"},{"type":"extras","title":"Regenerating Migrations - Migrations","doc":"Often, you will run into a situation where you want to make a slight change to a resource after you've already generated and run migrations. If you are using git and would like to undo those changes, then regenerate the migrations, this script may prove useful:\n\n```bash\n#!/bin/bash\n\n# Get count of untracked migrations\nN_MIGRATIONS=$(git ls-files --others priv/repo/migrations | wc -l)\n\n# Rollback untracked migrations\nmix ash_sqlite.rollback -n $N_MIGRATIONS\n\n# Delete untracked migrations and snapshots\ngit ls-files --others priv/repo/migrations | xargs rm\ngit ls-files --others priv/resource_snapshots | xargs rm\n\n# Regenerate migrations\nmix ash.codegen --name $1\n\n# Run migrations if flag\nif echo $* | grep -e \"-m\" -q\nthen\n  mix ash.migrate\nfi\n```\n\nAfter saving this file to something like `regen.sh`, make it executable with `chmod +x regen.sh`. Now you can run it with `./regen.sh name_of_operation`. If you would like the migrations to automatically run after regeneration, add the `-m` flag: `./regen.sh name_of_operation -m`.","ref":"migrations-and-tasks.html#regenerating-migrations"},{"type":"extras","title":"Multiple Repos - Migrations","doc":"If you are using multiple repos, you will likely need to use `mix ecto.migrate` and manage it separately for each repo, as the options would\nbe applied to both repo, which wouldn't make sense.","ref":"migrations-and-tasks.html#multiple-repos"},{"type":"extras","title":"Running Migrations in Production - Migrations","doc":"Define a module similar to the following:\n\n```elixir\ndefmodule MyApp.Release do\n  @moduledoc \"\"\"\n  Houses tasks that need to be executed in the released application (because mix is not present in releases).\n  \"\"\"\n  @app :my_ap\n  def migrate do\n    load_app()\n\n    for repo <- repos() do\n      {:ok, _, _} = Ecto.Migrator.with_repo(repo, &Ecto.Migrator.run(&1, :up, all: true))\n    end\n  end\n\n  def rollback(repo, version) do\n    load_app()\n    {:ok, _, _} = Ecto.Migrator.with_repo(repo, &Ecto.Migrator.run(&1, :down, to: version))\n  end\n\n  defp repos do\n    domains()\n    |> Enum.flat_map(fn domain ->\n      domain\n      |> Ash.Domain.Info.resources()\n      |> Enum.map(&AshSqlite.repo/1)\n    end)\n    |> Enum.uniq()\n  end\n\n  defp domains do\n    Application.fetch_env!(:my_app, :ash_domains)\n  end\n\n  defp load_app do\n    Application.load(@app)\n  end\nend\n```\n\n# AshSqlite-specific tasks\n\n- `mix ash_sqlite.generate_migrations`\n- `mix ash_sqlite.create`\n- `mix ash_sqlite.migrate`\n- `mix ash_sqlite.rollback`\n- `mix ash_sqlite.drop`","ref":"migrations-and-tasks.html#running-migrations-in-production"},{"type":"extras","title":"Testing With Sqlite","doc":"# Testing With Sqlite\n\nTesting resources with SQLite generally requires passing `async?: false` to\nyour tests, due to `SQLite`'s limitation of having a single write transaction\nopen at any one time.\n\nThis should be coupled with to make sure that Ash does not spawn any tasks.\n\n```elixir\nconfig :ash, :disable_async?, true\n```","ref":"testing.html"},{"type":"extras","title":"Expressions","doc":"# Expressions\n\nIn addition to the expressions listed in the [Ash expressions guide](https://hexdocs.pm/ash/expressions.html), AshSqlite provides the following expressions\n\n# Fragments\n\nFragments allow you to use arbitrary sqlite expressions in your queries. Fragments can often be an escape hatch to allow you to do things that don't have something officially supported with Ash.","ref":"expressions.html"},{"type":"extras","title":"Examples - Expressions","doc":"#### Simple expressions\n\n```elixir\nfragment(\"? / ?\", points, count)\n```\n\n#### Calling functions\n\n```elixir\nfragment(\"repeat('hello', 4)\")\n```\n\n#### Using entire queries\n\n```elixir\nfragment(\"points > (SELECT SUM(points) FROM games WHERE user_id = ? AND id != ?)\", user_id, id)\n```\n\n>","ref":"expressions.html#examples"},{"type":"extras","title":"a last resport - Expressions","doc":">\n> Using entire queries as shown above is a last resort, but can sometimes be the best way to accomplish a given task.\n\n#### In calculations\n\n```elixir\ncalculations do\n  calculate :lower_name, :string, expr(\n    fragment(\"LOWER(?)\", name)\n  )\nend\n```\n\n#### In migrations\n\n```elixir\ncreate table(:managers, primary_key: false) do\n  add :id, :uuid, null: false, default: fragment(\"UUID_GENERATE_V4()\"), primary_key: true\nend\n```","ref":"expressions.html#a-last-resport"},{"type":"extras","title":"Like - Expressions","doc":"These wrap the sqlite builtin like operator\n\nPlease be aware, these match _patterns_ not raw text. Use `contains/1` if you want to match text without supporting patterns, i.e `%` and `_` have semantic meaning!\n\nFor example:\n\n```elixir\nAsh.Query.filter(User, like(name, \"%obo%\")) # name contains obo anywhere in the string, case sensitively\n```","ref":"expressions.html#like"},{"type":"extras","title":"Join Manual Relationships","doc":"# Join Manual Relationships\n\nSee [Defining Manual Relationships](https://hexdocs.pm/ash/defining-manual-relationships.html) for an idea of manual relationships in general.\nManual relationships allow for expressing complex/non-typical relationships between resources in a standard way.\nIndividual data layers may interact with manual relationships in their own way, so see their corresponding guides.","ref":"manual-relationships.html"},{"type":"extras","title":"Example - Join Manual Relationships","doc":"```elixir\n# in the resource\n\nrelationships do\n  has_many :tickets_above_threshold, Helpdesk.Support.Ticket do\n    manual Helpdesk.Support.Ticket.Relationships.TicketsAboveThreshold\n  end\nend\n\n# implementation\ndefmodule Helpdesk.Support.Ticket.Relationships.TicketsAboveThreshold do\n  use Ash.Resource.ManualRelationship\n  use AshSqlite.ManualRelationship\n\n  require Ash.Query\n  require Ecto.Query\n\n  def load(records, _opts, %{query: query, actor: actor, authorize?: authorize?}) do\n    # Use existing records to limit resultds\n    rep_ids = Enum.map(records, & &1.id)\n     # Using Ash to get the destination records is ideal, so you can authorize access like normal\n     # but if you need to use a raw ecto query here, you can. As long as you return the right structure.\n\n    {:ok,\n     query\n     |> Ash.Query.filter(representative_id in ^rep_ids)\n     |> Ash.Query.filter(priority > representative.priority_threshold)\n     |> Helpdesk.Support.read!(actor: actor, authorize?: authorize?)\n     # Return the items grouped by the primary key of the source, i.e representative.id => [...tickets above threshold]\n     |> Enum.group_by(& &1.representative_id)}\n  end\n\n  # query is the \"source\" query that is being built. \n\n  # _opts are options provided to the manual relationship, i.e `{Manual, opt: :val}`\n\n  # current_binding is what the source of the relationship is bound to. Access fields with `as(^current_binding).field`\n\n  # as_binding is the binding that your join should create. When you join, make sure you say `as: ^as_binding` on the\n  # part of the query that represents the destination of the relationship\n\n  # type is `:inner` or `:left`.\n  # destination_query is what you should join to to add the destination to the query, i.e `join: dest in ^destination-query`\n  def ash_sqlite_join(query, _opts, current_binding, as_binding, :inner, destination_query) do\n    {:ok,\n     Ecto.Query.from(_ in query,\n       join: dest in ^destination_query,\n       as: ^as_binding,\n       on: dest.representative_id == as(^current_binding).id,\n       on: dest.priority > as(^current_binding).priority_threshold\n     )}\n  end\n\n  def ash_sqlite_join(query, _opts, current_binding, as_binding, :left, destination_query) do\n    {:ok,\n     Ecto.Query.from(_ in query,\n       left_join: dest in ^destination_query,\n       as: ^as_binding,\n       on: dest.representative_id == as(^current_binding).id,\n       on: dest.priority > as(^current_binding).priority_threshold\n     )}\n  end\n\n  # _opts are options provided to the manual relationship, i.e `{Manual, opt: :val}`\n\n  # current_binding is what the source of the relationship is bound to. Access fields with `parent_as(^current_binding).field`\n\n  # as_binding is the binding that has already been created for your join. Access fields on it via `as(^as_binding)`\n\n  # destination_query is what you should use as the basis of your query\n  def ash_sqlite_subquery(_opts, current_binding, as_binding, destination_query) do\n    {:ok,\n     Ecto.Query.from(_ in destination_query,\n       where: parent_as(^current_binding).id == as(^as_binding).representative_id,\n       where: as(^as_binding).priority > parent_as(^current_binding).priority_threshold\n     )}\n  end\nend\n```","ref":"manual-relationships.html#example"},{"type":"DSL","title":"sqlite - dsl-ashsqlite-datalayer","doc":"Sqlite data layer configuration","ref":"dsl-ashsqlite-datalayer.html#sqlite"},{"type":"DSL","title":"sqlite.repo - dsl-ashsqlite-datalayer","doc":"The repo that will be used to fetch your data. See the `AshSqlite.Repo` documentation for more","ref":"dsl-ashsqlite-datalayer.html#sqlite-repo"},{"type":"DSL","title":"sqlite.migrate? - dsl-ashsqlite-datalayer","doc":"Whether or not to include this resource in the generated migrations with `mix ash.generate_migrations`","ref":"dsl-ashsqlite-datalayer.html#sqlite-migrate?"},{"type":"DSL","title":"sqlite.migration_types - dsl-ashsqlite-datalayer","doc":"A keyword list of attribute names to the ecto migration type that should be used for that attribute. Only necessary if you need to override the defaults.","ref":"dsl-ashsqlite-datalayer.html#sqlite-migration_types"},{"type":"DSL","title":"sqlite.migration_defaults - dsl-ashsqlite-datalayer","doc":"A keyword list of attribute names to the ecto migration default that should be used for that attribute. The string you use will be placed verbatim in the migration. Use fragments like `fragment(\\\\\"now()\\\\\")`, or for `nil`, use `\\\\\"nil\\\\\"`.","ref":"dsl-ashsqlite-datalayer.html#sqlite-migration_defaults"},{"type":"DSL","title":"sqlite.base_filter_sql - dsl-ashsqlite-datalayer","doc":"A raw sql version of the base_filter, e.g `representative = true`. Required if trying to create a unique constraint on a resource with a base_filter","ref":"dsl-ashsqlite-datalayer.html#sqlite-base_filter_sql"},{"type":"DSL","title":"sqlite.skip_unique_indexes - dsl-ashsqlite-datalayer","doc":"Skip generating unique indexes when generating migrations","ref":"dsl-ashsqlite-datalayer.html#sqlite-skip_unique_indexes"},{"type":"DSL","title":"sqlite.unique_index_names - dsl-ashsqlite-datalayer","doc":"A list of unique index names that could raise errors that are not configured in identities, or an mfa to a function that takes a changeset and returns the list. In the format `{[:affected, :keys], \"name_of_constraint\"}` or `{[:affected, :keys], \"name_of_constraint\", \"custom error message\"}`","ref":"dsl-ashsqlite-datalayer.html#sqlite-unique_index_names"},{"type":"DSL","title":"sqlite.exclusion_constraint_names - dsl-ashsqlite-datalayer","doc":"A list of exclusion constraint names that could raise errors. Must be in the format `{:affected_key, \"name_of_constraint\"}` or `{:affected_key, \"name_of_constraint\", \"custom error message\"}`","ref":"dsl-ashsqlite-datalayer.html#sqlite-exclusion_constraint_names"},{"type":"DSL","title":"sqlite.identity_index_names - dsl-ashsqlite-datalayer","doc":"A keyword list of identity names to the unique index name that they should use when being managed by the migration generator.","ref":"dsl-ashsqlite-datalayer.html#sqlite-identity_index_names"},{"type":"DSL","title":"sqlite.foreign_key_names - dsl-ashsqlite-datalayer","doc":"A list of foreign keys that could raise errors, or an mfa to a function that takes a changeset and returns a list. In the format: `{:key, \"name_of_constraint\"}` or `{:key, \"name_of_constraint\", \"custom error message\"}`","ref":"dsl-ashsqlite-datalayer.html#sqlite-foreign_key_names"},{"type":"DSL","title":"sqlite.migration_ignore_attributes - dsl-ashsqlite-datalayer","doc":"A list of attributes that will be ignored when generating migrations.","ref":"dsl-ashsqlite-datalayer.html#sqlite-migration_ignore_attributes"},{"type":"DSL","title":"sqlite.table - dsl-ashsqlite-datalayer","doc":"The table to store and read the resource from. If this is changed, the migration generator will not remove the old table.","ref":"dsl-ashsqlite-datalayer.html#sqlite-table"},{"type":"DSL","title":"sqlite.polymorphic? - dsl-ashsqlite-datalayer","doc":"Declares this resource as polymorphic. See the [polymorphic resources guide](/documentation/topics/resources/polymorphic-resources.md) for more.","ref":"dsl-ashsqlite-datalayer.html#sqlite-polymorphic?"},{"type":"DSL","title":"sqlite.strict? - dsl-ashsqlite-datalayer","doc":"Whether the migration generator should create a [strict table](https://www.sqlite.org/stricttables.html), which enforces types more strictly.","ref":"dsl-ashsqlite-datalayer.html#sqlite-strict?"},{"type":"DSL","title":"sqlite.custom_indexes - dsl-ashsqlite-datalayer","doc":"A section for configuring indexes to be created by the migration generator.\n\nIn general, prefer to use `identities` for simple unique constraints. This is a tool to allow\nfor declaring more complex indexes.","ref":"dsl-ashsqlite-datalayer.html#sqlite-custom_indexes"},{"type":"DSL","title":"sqlite.custom_indexes.index - dsl-ashsqlite-datalayer","doc":"Add an index to be managed by the migration generator.","ref":"dsl-ashsqlite-datalayer.html#sqlite-custom_indexes-index"},{"type":"DSL","title":"sqlite.custom_indexes.index.fields - dsl-ashsqlite-datalayer","doc":"The fields to include in the index.","ref":"dsl-ashsqlite-datalayer.html#sqlite-custom_indexes-index-fields"},{"type":"DSL","title":"sqlite.custom_indexes.index.name - dsl-ashsqlite-datalayer","doc":"the name of the index. Defaults to \"#{table}_#{column}_index\".","ref":"dsl-ashsqlite-datalayer.html#sqlite-custom_indexes-index-name"},{"type":"DSL","title":"sqlite.custom_indexes.index.unique - dsl-ashsqlite-datalayer","doc":"indicates whether the index should be unique.","ref":"dsl-ashsqlite-datalayer.html#sqlite-custom_indexes-index-unique"},{"type":"DSL","title":"sqlite.custom_indexes.index.using - dsl-ashsqlite-datalayer","doc":"configures the index type.","ref":"dsl-ashsqlite-datalayer.html#sqlite-custom_indexes-index-using"},{"type":"DSL","title":"sqlite.custom_indexes.index.where - dsl-ashsqlite-datalayer","doc":"specify conditions for a partial index.","ref":"dsl-ashsqlite-datalayer.html#sqlite-custom_indexes-index-where"},{"type":"DSL","title":"sqlite.custom_indexes.index.message - dsl-ashsqlite-datalayer","doc":"A custom message to use for unique indexes that have been violated","ref":"dsl-ashsqlite-datalayer.html#sqlite-custom_indexes-index-message"},{"type":"DSL","title":"sqlite.custom_indexes.index.include - dsl-ashsqlite-datalayer","doc":"specify fields for a covering index. This is not supported by all databases. For more information on SQLite support, please read the official docs.","ref":"dsl-ashsqlite-datalayer.html#sqlite-custom_indexes-index-include"},{"type":"DSL","title":"sqlite.custom_statements - dsl-ashsqlite-datalayer","doc":"A section for configuring custom statements to be added to migrations.\n\nChanging custom statements may require manual intervention, because Ash can't determine what order they should run\nin (i.e if they depend on table structure that you've added, or vice versa). As such, any `down` statements we run\nfor custom statements happen first, and any `up` statements happen last.\n\nAdditionally, when changing a custom statement, we must make some assumptions, i.e that we should migrate\nthe old structure down using the previously configured `down` and recreate it.\n\nThis may not be desired, and so what you may end up doing is simply modifying the old migration and deleting whatever was\ngenerated by the migration generator. As always: read your migrations after generating them!","ref":"dsl-ashsqlite-datalayer.html#sqlite-custom_statements"},{"type":"DSL","title":"sqlite.custom_statements.statement - dsl-ashsqlite-datalayer","doc":"Add a custom statement for migrations.","ref":"dsl-ashsqlite-datalayer.html#sqlite-custom_statements-statement"},{"type":"DSL","title":"sqlite.custom_statements.statement.name - dsl-ashsqlite-datalayer","doc":"The name of the statement, must be unique within the resource","ref":"dsl-ashsqlite-datalayer.html#sqlite-custom_statements-statement-name"},{"type":"DSL","title":"sqlite.custom_statements.statement.code? - dsl-ashsqlite-datalayer","doc":"By default, we place the strings inside of ecto migration's `execute/1` function and assume they are sql. Use this option if you want to provide custom elixir code to be placed directly in the migrations","ref":"dsl-ashsqlite-datalayer.html#sqlite-custom_statements-statement-code?"},{"type":"DSL","title":"sqlite.custom_statements.statement.up - dsl-ashsqlite-datalayer","doc":"How to create the structure of the statement","ref":"dsl-ashsqlite-datalayer.html#sqlite-custom_statements-statement-up"},{"type":"DSL","title":"sqlite.custom_statements.statement.down - dsl-ashsqlite-datalayer","doc":"How to tear down the structure of the statement","ref":"dsl-ashsqlite-datalayer.html#sqlite-custom_statements-statement-down"},{"type":"DSL","title":"sqlite.references - dsl-ashsqlite-datalayer","doc":"A section for configuring the references (foreign keys) in resource migrations.\n\nThis section is only relevant if you are using the migration generator with this resource.\nOtherwise, it has no effect.","ref":"dsl-ashsqlite-datalayer.html#sqlite-references"},{"type":"DSL","title":"sqlite.references.polymorphic_on_delete - dsl-ashsqlite-datalayer","doc":"For polymorphic resources, configures the on_delete behavior of the automatically generated foreign keys to source tables.","ref":"dsl-ashsqlite-datalayer.html#sqlite-references-polymorphic_on_delete"},{"type":"DSL","title":"sqlite.references.polymorphic_on_update - dsl-ashsqlite-datalayer","doc":"For polymorphic resources, configures the on_update behavior of the automatically generated foreign keys to source tables.","ref":"dsl-ashsqlite-datalayer.html#sqlite-references-polymorphic_on_update"},{"type":"DSL","title":"sqlite.references.polymorphic_name - dsl-ashsqlite-datalayer","doc":"For polymorphic resources, configures the on_update behavior of the automatically generated foreign keys to source tables.","ref":"dsl-ashsqlite-datalayer.html#sqlite-references-polymorphic_name"},{"type":"DSL","title":"sqlite.references.reference - dsl-ashsqlite-datalayer","doc":"Configures the reference for a relationship in resource migrations.\n\nKeep in mind that multiple relationships can theoretically involve the same destination and foreign keys.\nIn those cases, you only need to configure the `reference` behavior for one of them. Any conflicts will result\nin an error, across this resource and any other resources that share a table with this one. For this reason,\ninstead of adding a reference configuration for `:nothing`, its best to just leave the configuration out, as that\nis the default behavior if *no* relationship anywhere has configured the behavior of that reference.","ref":"dsl-ashsqlite-datalayer.html#sqlite-references-reference"},{"type":"DSL","title":"sqlite.references.reference.relationship - dsl-ashsqlite-datalayer","doc":"The relationship to be configured","ref":"dsl-ashsqlite-datalayer.html#sqlite-references-reference-relationship"},{"type":"DSL","title":"sqlite.references.reference.ignore? - dsl-ashsqlite-datalayer","doc":"If set to true, no reference is created for the given relationship. This is useful if you need to define it in some custom way","ref":"dsl-ashsqlite-datalayer.html#sqlite-references-reference-ignore?"},{"type":"DSL","title":"sqlite.references.reference.on_delete - dsl-ashsqlite-datalayer","doc":"What should happen to records of this resource when the referenced record of the *destination* resource is deleted.","ref":"dsl-ashsqlite-datalayer.html#sqlite-references-reference-on_delete"},{"type":"DSL","title":"sqlite.references.reference.on_update - dsl-ashsqlite-datalayer","doc":"What should happen to records of this resource when the referenced destination_attribute of the *destination* record is update.","ref":"dsl-ashsqlite-datalayer.html#sqlite-references-reference-on_update"},{"type":"DSL","title":"sqlite.references.reference.deferrable - dsl-ashsqlite-datalayer","doc":"Wether or not the constraint is deferrable. This only affects the migration generator.","ref":"dsl-ashsqlite-datalayer.html#sqlite-references-reference-deferrable"},{"type":"DSL","title":"sqlite.references.reference.name - dsl-ashsqlite-datalayer","doc":"The name of the foreign key to generate in the database. Defaults to  _ _fkey","ref":"dsl-ashsqlite-datalayer.html#sqlite-references-reference-name"},{"type":"extras","title":"Change Log","doc":"# Change Log\n\nAll notable changes to this project will be documented in this file.\nSee [Conventional Commits](Https://conventionalcommits.org) for commit guidelines.\n\n<!-- changelog -->\n\n## [v0.2.11](https://github.com/ash-project/ash_sqlite/compare/v0.2.10...v0.2.11) (2025-06-16)","ref":"changelog.html"},{"type":"extras","title":"Improvements: - Change Log","doc":"* support update_query and destroy_query by Zach Daniel\n\n## [v0.2.10](https://github.com/ash-project/ash_sqlite/compare/v0.2.9...v0.2.10) (2025-06-15)","ref":"changelog.html#improvements"},{"type":"extras","title":"Bug Fixes: - Change Log","doc":"* properly apply filters on destroy & update by Zach Daniel\n\n## [v0.2.9](https://github.com/ash-project/ash_sqlite/compare/v0.2.8...v0.2.9) (2025-05-30)","ref":"changelog.html#bug-fixes"},{"type":"extras","title":"Bug Fixes: - Change Log","doc":"* properly fetch options in installer","ref":"changelog.html#bug-fixes-1"},{"type":"extras","title":"Improvements: - Change Log","doc":"* strict table support (#157)\n\n* support new PendingCodegen error\n\n## [v0.2.8](https://github.com/ash-project/ash_sqlite/compare/v0.2.7...v0.2.8) (2025-05-29)","ref":"changelog.html#improvements-1"},{"type":"extras","title":"Bug Fixes: - Change Log","doc":"* properly fetch options in installer","ref":"changelog.html#bug-fixes-2"},{"type":"extras","title":"Improvements: - Change Log","doc":"* --dev codegen flag (#154)\n\n## [v0.2.7](https://github.com/ash-project/ash_sqlite/compare/v0.2.6...v0.2.7) (2025-05-26)","ref":"changelog.html#improvements-2"},{"type":"extras","title":"Bug Fixes: - Change Log","doc":"* various fixes around parameterized type data shape change\n\n* Remove unused `:inflex` dependency\n\n* Fix leftover reference to `Inflex` after it was moved to Igniter instead","ref":"changelog.html#bug-fixes-3"},{"type":"extras","title":"Improvements: - Change Log","doc":"* Fix igniter deprecation warning. (#152)\n\n## [v0.2.6](https://github.com/ash-project/ash_sqlite/compare/v0.2.5...v0.2.6) (2025-04-29)","ref":"changelog.html#improvements-3"},{"type":"extras","title":"Bug Fixes: - Change Log","doc":"* ensure upsert_fields honor update_defaults\n\n* ensure all upsert_fields are accounted for\n\n## [v0.2.5](https://github.com/ash-project/ash_sqlite/compare/v0.2.4...v0.2.5) (2025-03-11)","ref":"changelog.html#bug-fixes-4"},{"type":"extras","title":"Bug Fixes: - Change Log","doc":"* Handle empty upsert fields (#135)\n\n## [v0.2.4](https://github.com/ash-project/ash_sqlite/compare/v0.2.3...v0.2.4) (2025-02-25)","ref":"changelog.html#bug-fixes-5"},{"type":"extras","title":"Bug Fixes: - Change Log","doc":"* remove list literal usage for `in` in ash_sqlite\n\n## [v0.2.3](https://github.com/ash-project/ash_sqlite/compare/v0.2.2...v0.2.3) (2025-01-26)","ref":"changelog.html#bug-fixes-6"},{"type":"extras","title":"Bug Fixes: - Change Log","doc":"* use `AshSql` for running aggregate queries","ref":"changelog.html#bug-fixes-7"},{"type":"extras","title":"Improvements: - Change Log","doc":"* update ash version for better aggregate support validation\n\n## [v0.2.2](https://github.com/ash-project/ash_sqlite/compare/v0.2.1...v0.2.2) (2025-01-22)","ref":"changelog.html#improvements-4"},{"type":"extras","title":"Bug Fixes: - Change Log","doc":"* Remove a postgresql specific configuration from `ash_sqlite.install` (#103)","ref":"changelog.html#bug-fixes-8"},{"type":"extras","title":"Improvements: - Change Log","doc":"* add installer for sqlite\n\n* make igniter optional\n\n* improve dry_run logic and fix priv path setup\n\n* honor repo configs and add snapshot configs\n\n## [v0.2.1](https://github.com/ash-project/ash_sqlite/compare/v0.2.0...v0.2.1) (2024-10-09)","ref":"changelog.html#improvements-5"},{"type":"extras","title":"Bug Fixes: - Change Log","doc":"* don't raise error on codegen with no domains\n\n* installer: use correct module name in the `DataCase` moduledocs. (#82)","ref":"changelog.html#bug-fixes-9"},{"type":"extras","title":"Improvements: - Change Log","doc":"* add `--repo` option to installer, warn on clashing existing repo\n\n* modify mix task aliases according to installer\n\n## [v0.2.0](https://github.com/ash-project/ash_sqlite/compare/v0.1.3...v0.2.0) (2024-09-10)","ref":"changelog.html#improvements-6"},{"type":"extras","title":"Features: - Change Log","doc":"* add igniter-based AshSqlite.Install mix task (#66)","ref":"changelog.html#features"},{"type":"extras","title":"Improvements: - Change Log","doc":"* fix warnings from latest igniter updates\n\n## [v0.1.3](https://github.com/ash-project/ash_sqlite/compare/v0.1.2...v0.1.3) (2024-05-31)","ref":"changelog.html#improvements-7"},{"type":"extras","title":"Bug Fixes: - Change Log","doc":"* use `Ecto.ParameterizedType.init/2`\n\n* handle new/old ecto parameterized type format\n\n## [v0.1.2](https://github.com/ash-project/ash_sqlite/compare/v0.1.2-rc.1...v0.1.2) (2024-05-11)\n\n\n\n\n## [v0.1.2-rc.1](https://github.com/ash-project/ash_sqlite/compare/v0.1.2-rc.0...v0.1.2-rc.1) (2024-05-06)","ref":"changelog.html#bug-fixes-10"},{"type":"extras","title":"Bug Fixes: - Change Log","doc":"* properly scope deletes to the records in question\n\n* update ash_sqlite to get `ilike` behavior fix","ref":"changelog.html#bug-fixes-11"},{"type":"extras","title":"Improvements: - Change Log","doc":"* support `contains` function\n\n## [v0.1.2-rc.0](https://github.com/ash-project/ash_sqlite/compare/v0.1.1...v0.1.2-rc.0) (2024-04-15)","ref":"changelog.html#improvements-8"},{"type":"extras","title":"Bug Fixes: - Change Log","doc":"* reenable mix tasks that we need to call","ref":"changelog.html#bug-fixes-12"},{"type":"extras","title":"Improvements: - Change Log","doc":"* support `mix ash.rollback`\n\n* support Ash 3.0, leverage `ash_sql` package\n\n* fix datetime migration type discovery\n\n## [v0.1.1](https://github.com/ash-project/ash_sqlite/compare/v0.1.0...v0.1.1) (2023-10-12)","ref":"changelog.html#improvements-9"},{"type":"extras","title":"Improvements: - Change Log","doc":"* add `SqliteMigrationDefault`\n\n* support query aggregates\n\n## [v0.1.0](https://github.com/ash-project/ash_sqlite/compare/v0.1.0...v0.1.0) (2023-10-12)","ref":"changelog.html#improvements-10"},{"type":"extras","title":"Improvements: - Change Log","doc":"* Port and adjust `AshPostgres` to `AshSqlite`","ref":"changelog.html#improvements-11"}],"proglang":"elixir","content_type":"text/markdown","producer":{"name":"ex_doc","version":"0.38.2"}}